local u = require("utils")

vim.keymap.set("n", "<leader>pv", vim.cmd.Ex)
vim.keymap.set("n", "<leader>h", ":noh<CR>")

--move line shortcut
vim.keymap.set("n", "<M-j>", ":m +1<CR>==", {noremap = true})
vim.keymap.set("n", "<M-k>", ":m -2<CR>==", {noremap = true})

vim.keymap.set("v", "<M-j>", ":m '>+1<CR>gv=gv", {noremap = true})
vim.keymap.set("v", "<M-k>", ":m '<-2<CR>gv=gv", {noremap = true})

vim.keymap.set("n", "<C-d>", "<C-d>zz", {noremap = true})
vim.keymap.set("n", "<C-u>", "<C-u>zz", {noremap = true})

vim.keymap.set("x", "<leader>p", "\"_dP")

--tab buffer
vim.keymap.set("n", "<leader>fn", ":bnext<CR>", {noremap = true})
vim.keymap.set("n", "<leader>fp", ":bprev<CR>", {noremap = true})

-- wrap toggle
vim.keymap.set("n", "<leader>w", function() vim.o.wrap = not vim.o.wrap end, {noremap = true})

vim.o.clipboard = 'unnamedplus'

-- Diff mappings put/get then move to next change
-- u.nmap("<leader>dg", "<CMD>diffget<CR>]c")
-- u.nmap("<leader>dp", "<CMD>diffput<CR>]c")
-- 
-- u.nmap("<leader>dp", "<CMD>diffput<CR>]c")
-- 
-- -- Remap movement to move by column layout
-- u.nvmap("j", "gj")
-- u.nvmap("k", "gk")
-- 
-- u.nvmap(";", ":")

-- Window splitting remap"
u.nmap("<C-h>", "<C-w>h")
u.nmap("<C-k>", "<C-w>k")
u.nmap("<C-l>", "<C-w>l")
u.nmap("<C-j>", "<C-w>j")
-- u.nmap("<C-w>z", ":cclose<CR>")
-- 
-- -- Exit terminal insert mode
-- u.tmap("<Esc>", "<C-\\><C-n>")
-- 
-- -- Delete buffer without closing the window
-- u.nmap("<leader>q", ":bp<bar>sp<bar>bn<bar>bd<CR>")
-- 
-- Fugitive
-- u.nmap("<leader>gw", ":Gwrite<CR>")
-- u.nmap("<leader>gr", ":Gread<CR>")
-- u.nmap("<leader>gc", ":Git commit -v<CR>")
-- u.nmap("<leader>gC", ":Git commit -v --amend<CR>")
-- u.nmap("<leader>gs", ":Git<CR>")
-- u.nmap("<leader>gd", ":Gdiff<CR>")
u.nmap("<leader>gb", ":Git blame<CR>")

u.nmap("<C-d>", "<C-d>zz")
u.nmap("<C-u>", "<C-u>zz")

u.nmap("<leader>ri", ":lua vim.lsp.inlay_hint(0)<CR>")
u.nmap("<leader>rl", ":RustFmt<CR>")

vim.keymap.set("n", "<leader>ri", function() vim.lsp.inlay_hint.enable(not vim.lsp.inlay_hint.is_enabled({0}), {0}) end)
u.nmap("<leader>d", ":lua vim.lsp.buf.hover()<CR>")


require("telescope-config")
require("minifiles-config")
require("vimtex-config")
