local opt = vim.o-- global options

vim.lsp.set_log_level("off")

-- Theme
-- Options
opt.relativenumber = true
opt.colorcolumn = "80"
opt.number = true
opt.tabstop = 2
opt.softtabstop = 2
opt.shiftwidth = 2
opt.expandtab = true
opt.smartindent = true

-- Make line numbers default
vim.wo.number = true

-- Enable mouse mode
opt.mouse = 'a'

-- Sync clipboard between OS and Neovim.
opt.clipboard = 'unnamedplus'

-- Enable break indent
opt.breakindent = true

-- Save undo history
opt.undofile = true

-- Keep signcolumn on by default
vim.wo.signcolumn = 'yes'

-- Decrease update time
opt.updatetime = 250
opt.timeoutlen = 300

-- Set completeopt to have a better completion experience
opt.completeopt = 'menuone,noselect'

--ignore case if pattern doesn't contain upper case
opt.ignorecase = true
opt.smartcase = true

--number of line to show around the cursor
opt.scrolloff = 8

-- vim.g.rustfmt_autosave = 1
