local telescope = require('telescope')
local lga_actions = require("telescope-live-grep-args.actions")
local builtin = require('telescope.builtin')
local live_grep_args_shortcuts = require("telescope-live-grep-args.shortcuts")

telescope.setup {
  defaults = {
    mappings = {
      i = {
        ['<C-u>'] = false,
        ['<C-d>'] = false,
        ["<C-k>"] = lga_actions.quote_prompt(),
      },
    },
  },
}
telescope.load_extension("live_grep_args")

vim.keymap.set('n', '<leader>pf', builtin.find_files, {noremap = true})
vim.keymap.set("n", "<leader>pg", telescope.extensions.live_grep_args.live_grep_args)
vim.keymap.set('n', '<leader>lg', builtin.live_grep, {noremap = true})

vim.keymap.set("n", "<leader>pw", live_grep_args_shortcuts.grep_word_under_cursor)
